#!/bin/sh

echo "Content-type: text/html; charset=utf-8"
echo ""
echo "<head><title>Moviemanager</title></head>"
echo "<body>"

# show name date scrambling info (delete exept txt and ts) delete all , delete ?? rename
. /dtv/SGO.env
SELF=Moviemanager.cgi

scrambled() {
	FLAG="error"
	for i in 1 2 3 4 5 6 7 8; do
		RUN=$((188 * $i + 3))
		dd if="$1" bs=1 count=1 skip="$RUN" status=noxfer 2>/dev/null |\
			xxd -b | busybox awk '{ print $2 }' | busybox grep -q "^1" && FLAG="red" && break
		FLAG="lime"
	done
### maybe add key check
	if [ $(echo $1 | busybox grep ".srf$") ]; then
		if [ "$FLAG" = "red" ]; then
			echo -n	"<th bgcolor="$FLAG"><a href=\"/cgi-bin/$SELF?decrypt+"$FILE"\">DECRYPT</a></th>"
		elif [ "$FLAG" = "lime" ]; then
			ln -sf "$FILE".srf /dtv/www/movie/"$NAMEUTF8.srf.mpg"
			echo -n "<th bgcolor="$FLAG"><a href="/movie/$NAMEUTF8.srf.mpg">"PLAY"</a></th>"
		elif [ "$FLAG" = "error" ]; then
			echo -n "<th><a><b>"ERROR"</b></a></th>"
		fi
	elif [ $(echo $1 | busybox grep ".ts$") ]; then
		if [ "$FLAG" = "red" ]; then
			echo -n	"<th bgcolor="$FLAG"><a>Encrypted TS</a></th>"
		elif [ "$FLAG" = "lime" ]; then
			ln -sf "$FILE".ts /dtv/www/movie/"$NAMEUTF8.ts.mpg"
			echo -n "<th bgcolor="$FLAG"><a href="/movie/$NAMEUTF8.ts.mpg">"PLAY"</a></th>"
		elif [ "$FLAG" = "error" ]; then
			echo -n "<th><a><b>"ERROR"</b></a></th>"
		fi
	fi
}
renamestring() {
	if [ $(echo $FILE | busybox grep "[0123456789]\{14\}") ]; then
		echo -n	"<a href=\"/cgi-bin/$SELF?rename+"$FILEPATH"+"$SAMYNAME"+"$NAMEUTF8"+"$FILEDATE""
		ls "$FILE"* | busybox grep "[0123456789]\{14\}" | sed 's_/dtv/usb/sd.*/CONTENTS/.*\.__' | while read FILEEXT ; do
			echo -n "+"$FILEEXT""
		done
		echo -n "\">rename</a>"
	else	echo -n "&nbsp;"
	fi
}

case "$1" in
	rename)
	if [ -z "$18" ]; then
		echo "This will rename $2$3 to $2$4_$5. Use on own risk, no check for overwriting files yet (not realy neccesary)."
		echo -n	"<a href=\"/cgi-bin/$SELF?renameok+"$2"+"$3"+"$4"+"$5"+"$6"+"$7"+"$8"+"$9"+"$10"+"$11"+"$12"+"$13"+"$14"+"$15"+"$16"+"$17"\">rename</a>"
	else
		echo "to many extensions"
	fi
	;;
	renameok)
	[ -n "$6" ] && mv $2$3.$6 $2$4_$5.$6
	[ -n "$7" ] && mv $2$3.$7 $2$4_$5.$7
	[ -n "$8" ] && mv $2$3.$8 $2$4_$5.$8
	[ -n "$9" ] && mv $2$3.$9 $2$4_$5.$9
	[ -n "$10" ] && mv $2$3.$10 $2$4_$5.$10
	[ -n "$11" ] && mv $2$3.$11 $2$4_$5.$11
	[ -n "$12" ] && mv $2$3.$12 $2$4_$5.$12
	[ -n "$13" ] && mv $2$3.$13 $2$4_$5.$13
	[ -n "$14" ] && mv $2$3.$14 $2$4_$5.$14
	[ -n "$15" ] && mv $2$3.$15 $2$4_$5.$15
	[ -n "$16" ] && mv $2$3.$16 $2$4_$5.$16
	[ -n "$17" ] && mv $2$3.$17 $2$4_$5.$17
	reload
	;;
	decrypt)
	[ -z $(pidof drmdecrypt_arm) ] && drmdecrypt_arm "$2".srf "$2".ts "$2".key || echo "Already Decrypting a File"
	;;
	*)
### Header
	echo "<body style=\"direction: ltr; background-color: rgb(255, 255, 255); width: 99%;\">"
	echo "<table style=\"width: 100%; margin-left: auto; margin-right: auto;\" border=\"1\">"
	echo "<tr><th width=\"33%\"></th><th width=\"33%\"></th><th width=\"33%\"></th></tr>"
	echo "<tr><th>"DATE"</th><th>"NAME"</th><th>"STATION"</th></tr>"
	echo "<tr><th bgcolor="red" colspan="3">"DESCRIPTION: Rename only Letters and Digits \(no Custom Renaming\), Charset might be wrong DECRYPT ARM Only"</th></tr>"
	echo "<tr><th>"LANGUAGE"</th><th>"FILMTYPE"</th><th>"RENAME"</th></tr>"
	echo "<tr><th>"TXT Info written when Green"</th><th>"Green/Red DRM and Decrypt or Play"</th><th>"DRM Key File"</th></tr>"
### Header END
	OPENFILE=$(ls -al /proc/$(pidof exeDSP)/fd/ | busybox grep -e ".srf$" -e ".tmp$" | sed 's_.*-> __' | sed 's_\..*__')
	[ -z $OPENFILE ] && OPENFILE="NO_OPEN_FILE"
	echo "<tr><th bgcolor="red" colspan="3">"Not Listed, because open by TV: "$OPENFILE""</th></tr>"
	echo "</table>"
	echo "<hr>"
	[ ! -d /dtv/www/movie/ ] && /bin/mkdir /dtv/www/movie/
	ls /dtv/usb/sd*/CONTENTS/*.inf | busybox grep -v NewBoard4Rpsp.inf | sed 's_.inf$__' | busybox grep -v $OPENFILE | while read FILE; do
### GET INFOS
		[ -f $FILE.srf ] && SIZESRF=$(ls -hl "$FILE".srf | busybox awk -F ' ' '{ print $5 }')
		[ -f $FILE.ts ] && SIZETS=$(ls -hl "$FILE".srf | busybox awk -F ' ' '{ print $5 }')
		[ ! -f "$FILE".key -a -f "$FILE".mdb ] && dd if="$FILE".mdb bs=1 skip=8 count=16 status=noxfer 2>/dev/null | sed -e "s/\(.\)\(.\)\(.\)\(.\)/\4\3\2\1/g" > "$FILE".key
		FILEPATH=$(echo $FILE | busybox grep -o "/dtv/usb/sd.*/CONTENTS/")
		SAMYNAME=$(echo $FILE | busybox grep -o "[0-9]\{14\}")
		FILEDATE=$(echo $FILE | busybox grep -o "[0-9]\{14\}" | sed -e "s/^\(....\)\(..\)\(..\)\(..\)\(..\)\(..\)/\1-\2-\3_\4-\5-\6/g")
		[ -z $FILEDATE ] && FILEDATE=$(echo $FILE | busybox grep -o "[0-9]\{4\}-[0-9]\{2\}-[0-9]\{2\}_[0-9]\{2\}-[0-9]\{2\}-[0-9]\{2\}")
		STATION=$(dd if=$FILE.inf bs=1 count=256 status=noxfer 2>/dev/null)
		NAMEUTF8=$(dd if=$FILE.inf bs=1 skip=256 count=256 status=noxfer 2>/dev/null | sed 's_ _\__g' | sed 's/[^A-z|0-9|-]/_/g')
		NAMEASCII=$(dd if=$FILE.inf bs=1 skip=792 count=524 status=noxfer 2>/dev/null | sed -e "s/\(.\)\(.\)/\2\1/g") #Other ENC
		DESCRIPTION=$(dd if=$FILE.inf bs=1 skip=1782 count=4622 status=noxfer 2>/dev/null)
		LANGUAGE=$(dd if=$FILE.inf bs=1 skip=6416 count=510 status=noxfer 2>/dev/null)
		FILMTYPE=$(dd if=$FILE.inf bs=1 skip=6926 count=256 status=noxfer 2>/dev/null) #Other ENC
		[ -z "$FILMTYPE" ] && FILMTYPE="&nbsp;"
		RENAMESTRING=$(renamestring)
### Write all infos to TXT if not exist
		if [ ! -f $FILE.txt ]; then
			echo ""$NAMEUTF8" on "$STATION" from "$FILEDATE"" > $FILE.txt
			echo "$DESCRIPTION" >> $FILE.txt
			echo ""$FILMTYPE" "$LANGUAGE"" >> $FILE.txt
		fi

		echo "<table style=\"width: 100%; margin-left: auto; margin-right: auto;\" border=\"1\">"
		echo "<tr><th width=\"33%\"></th><th width=\"33%\"></th><th width=\"33%\"></th></tr>"
### 1st Row
		echo "<tr><th bgcolor="Silver">"$FILEDATE"</th><th bgcolor="Silver">"$NAMEASCII"</th><th bgcolor="Silver">"$STATION"</th></tr>"
### 2nd Row
		echo "<tr><th colspan="3">"$DESCRIPTION"</th></tr>"
### 3rd Row
		echo -n "<tr><th>"$LANGUAGE"</th><th>"$FILMTYPE"</th><th>"$RENAMESTRING"</th></tr>"
		[ -f $FILE.txt ] && echo -n "<tr><th bgcolor="lime"><a href=\"/Temp2.php?"$FILE".inf\" target="_blank">TXT File</a></th>" || echo -n "<tr><th bgcolor="red">No TXT File</th>"
		if [ -f $FILE.ts ]; then scrambled ""$FILE".ts"
			elif [ -f $FILE.srf ]; then scrambled ""$FILE".srf"
			else echo -n "<th>"&nbsp;"</th>"
		fi
		[ -f $FILE.key ] && echo "<th bgcolor="lime">KEY File</th></tr>" || echo "<th bgcolor="red">No KEY File</th></tr>"
		echo "</table>"
		echo "<hr>"
	done
	;;
esac

echo "<form action="/cgi-bin/$SELF" method="GET">"
echo "<input type="submit" value="BACK" />"
echo "</form>"

echo "BUILD=2012-04-15"
echo "</body>"
