#!/bin/sh

echo "Content-type: text/html; charset=utf-8"
echo ""
echo "<head><title>Moviemanager</title>"

echo "<style type="text/css">"
echo "#tooltip1 { position: relative; }"
echo "#tooltip1 a span { display: none; color: #FFFFFF; }"
echo "#tooltip1 a:hover span { display: block; position: absolute; width: 250px; background-color: #aaa; height: 50px; left: 100px; top: -10px; color: #FFFFFF; padding: 5px; }"
echo "</style>"

echo "</head>"
echo "<body>"

. /dtv/SGO.env
SELF=Moviemanager2.cgi

#will output one filed in table
scrambled() {
	FLAG="error"
	for i in 1 2 3 4 5 6 7 8; do
		RUN=$((188 * $i + 3))
		dd if="$1" bs=1 count=1 skip="$RUN" status=noxfer 2>/dev/null |\
			xxd -b | busybox awk '{ print $2 }' | busybox grep -q "^1" && FLAG="red" && break
		FLAG="lime"
	done
### maybe add key check
	if [ $(echo $1 | busybox grep ".srf$") ]; then
		if [ "$FLAG" = "red" ]; then
			echo -n	"<th bgcolor="$FLAG"><a href=\"/cgi-bin/$SELF?decrypt+"$FILE"\">DECRYPT</a></th>"
		elif [ "$FLAG" = "lime" ]; then
			ln -sf "$FILE".srf /dtv/www/movie/"$NAMEUTF8.srf.mpg"
			echo -n "<th bgcolor="$FLAG"><a href="/movie/$NAMEUTF8.srf.mpg">"PLAY"</a></th>"
		elif [ "$FLAG" = "error" ]; then
			echo -n "<th><a><b>"ERROR"</b></a></th>"
		fi
	elif [ $(echo $1 | busybox grep ".ts$") ]; then
		if [ "$FLAG" = "red" ]; then
			echo -n	"<th bgcolor="$FLAG"><a>Encrypted TS</a></th>"
		elif [ "$FLAG" = "lime" ]; then
			ln -sf "$FILE".ts /dtv/www/movie/"$NAMEUTF8.ts.mpg"
			echo -n "<th bgcolor="$FLAG"><a href="/movie/$NAMEUTF8.ts.mpg">"PLAY"</a></th>"
		elif [ "$FLAG" = "error" ]; then
			echo -n "<th><a><b>"ERROR"</b></a></th>"
		fi
	fi
}

renamestring() {
	if [ $(echo $FILE | busybox grep "[0123456789]\{14\}") ]; then
		echo -n	"<a href=\"/cgi-bin/$SELF?askrename+"$FILE"+"$NAMEUTF8"\">Rename</a>"
	else	echo -n "&nbsp;"
	fi
}

case "$1" in
	askrename)
#needs rename and filename + newname ## on hover maybe?
	echo "Use on own risk, no check for overwriting files yet (not realy neccesary)."
	echo "This will rename:"
	echo "<pre>"
	ls "$2"* | while read FILE; do
		OLDNAME=$(echo $2 | awk -F '/' '{ print $NF }')
		NEWNAME=$(echo $FILE | sed 's:'$OLDNAME':'$(echo $OLDNAME | busybox grep -o "[0-9]\{14\}")'_-_'$3':g')
		echo "mv "$FILE" "$NEWNAME""
		[ -f "$NEWNAME" ] && echo "FILE ALREDAY EXISTING"
	done
	echo "</pre>"
	echo "<a href=\"/cgi-bin/$SELF?dorename+"$2"+"$3"\">CONFIRM</a>"
	;;

	dorename)
	ls "$2"* | while read FILE; do
		OLDNAME=$(echo $2 | awk -F '/' '{ print $NF }')
		NEWNAME=$(echo $FILE | sed 's:'$OLDNAME':'$OLDNAME'_-_'$3':g')
		mv "$FILE" "$NEWNAME"
	done
	;;
	askdelete)
	echo "This will delete:"
	ls "$2"* | while read FILE; do
		echo "<pre>"
		echo "rm "$FILE""
		echo "</pre>"
	done
		echo -n	"<a href=\"/cgi-bin/$SELF?dodelete+"$2"+"$3"\">CONFIRM</a>"
	;;

	dodelete)
	ls "$2"* | while read FILE; do
		rm "$FILE"
	done
	;;
	decrypt)

	if [ -z $(pidof drmdecrypt_arm) ];
	then
		[ ! -f "$2".key -a -f "$2".mdb ] && dd if="$2".mdb bs=1 skip=8 count=16 status=noxfer 2>/dev/null | sed -e "s/\(.\)\(.\)\(.\)\(.\)/\4\3\2\1/g" > "$2".key
		$SYSROOT/bin/busybox nohup drmdecrypt_arm "$2".srf "$2".ts "$2".key &
		rm "$2".key
	else	echo "Already Decrypting a File"
	fi
	;;

	*)
### Header
	echo "<body style=\"direction: ltr; background-color: rgb(255, 255, 255); width: 99%;\">"
	echo "<table style=\"width: 100%; margin-left: auto; margin-right: auto;\" border=\"1\">"
	echo "<tr><th width=\"200\"></th><th width=\"0\"></th><th width=\"100\"></th><th width=\"100\"></th><th width=\"100\"></th><th width=\"100\"></th></tr>"
	echo "<tr><th>"DATE"</th><th>"NAME"</th><th>"DRM"</th><th>"RENAME"</th><th>"DELETE"</th><th>"SIZE"</th></tr>"
### Header END
	OPENFILE=$(ls -al /proc/$(pidof exeDSP)/fd/ | busybox grep -e ".srf$" -e ".tmp$" | sed 's_.*-> __' | sed 's_\..*__')
	[ -z $OPENFILE ] && OPENFILE="NO_OPEN_FILE"
	[ "$OPENFILE" != "NO_OPEN_FILE" ] && echo "<tr><th bgcolor="red" colspan="5">"Not Listed, because open by TV: "$OPENFILE""</th></tr>"
	echo "</table>"
	echo "<hr>"
	[ ! -d /dtv/www/movie/ ] && /bin/mkdir /dtv/www/movie/
	ls /dtv/usb/sd*/CONTENTS/*.inf | busybox grep -v NewBoard4Rpsp.inf | sed 's_.inf$__' | busybox grep -v $OPENFILE | while read FILE; do
### GET INFOS
		FILEPATH=$(echo $FILE | busybox grep -o "/dtv/usb/sd.*/CONTENTS/")
		SAMYNAME=$(echo $FILE | busybox grep -o "[0-9]\{14\}")
		FILEDATE=$(echo $FILE | busybox grep -o "[0-9]\{14\}" | sed -e "s/^\(....\)\(..\)\(..\)\(..\)\(..\)\(..\)/\1-\2-\3 \4:\5:\6/g")
		[ -z "$FILEDATE" ] && FILEDATE=$(echo $FILE | busybox grep -o "[0-9]\{4\}-[0-9]\{2\}-[0-9]\{2\}_[0-9]\{2\}-[0-9]\{2\}-[0-9]\{2\}")
		NAMEUTF8=$(dd if=$FILE.inf bs=1 skip=256 count=256 status=noxfer 2>/dev/null | sed 's_ _\__g' | sed 's/[^A-z|0-9|-]/_/g')
		RENAMESTRING=$(renamestring)
		echo "<table style=\"width: 100%; margin-left: auto; margin-right: auto;\" border=\"0\">"
		echo "<tr><th width=\"200\"></th><th width=\"0\"></th><th width=\"100\"></th><th width=\"100\"></th><th width=\"100\"></th><th width=\"100\"></th></tr>"
		echo "<tr>"
### Field 1 DATE
		echo "<th bgcolor="Silver"><font size="-2">"$FILEDATE"</font></th>"
### Field 2 NAME
		echo "<th bgcolor="Silver"><p id=\"tooltip1\"><a href=\"/PVR_File_Info.php?$FILE.inf\">"$NAMEUTF8"<span>Will show more details from INF</span></a></th>"
### Field 3 DRM & PLAY
		if [ -f $FILE.ts ]; then scrambled ""$FILE".ts"
		elif [ -f $FILE.srf ]; then scrambled ""$FILE".srf"
		else echo -n "<th>"&nbsp;"</th>"
		fi
### Field 4 Rename
		echo "<th>"$RENAMESTRING"</th>"
### Field 5 DELETE
		echo "<th><a href=\"/cgi-bin/$SELF?askdelete+"$FILE"\">DELETE</a></th>"
### Field 6 SIZE
		echo "<th>$($SYSROOT/bin/busybox du -ch $FILE* | tail -1 | awk '{print $1}')</th>"
		echo "</tr>"
		echo "</table>"
		echo "<hr>"
	done
	;;
esac

echo "<form action="/cgi-bin/$SELF" method="GET">"
echo "<input type="submit" value="BACK" />"
echo "</form>"

echo "BUILD=2012-05-01"
echo "</body>"
